package bean;

import java.io.IOException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;

import com.google.gson.JsonArray;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;

public class WordKitAPI {
	// API KEY
	static final String SUBSCRIPTION_KEY="Your API KEY";
	//API URL
	static final String OPENAI_PORTAL_URL = "https://api.wordkit.cn/?";
	static CloseableHttpClient httpClient = HttpClients.createDefault();
	/**
	 * 请求API
	 * @param q 产品名称
	 * @param b 产品品牌名
	 * @param k 产品卖点关键词
	 * @param f 生成对象
	 * @param l 输出语种
	 * @return String list
	 * @throws IOException
	 */
	public static List<String> getAPI2023(String q, String b, String k, String f, String l) throws IOException {
		HttpGet httpGet = new HttpGet(OPENAI_PORTAL_URL + "q=" + URLEncoder.encode(q, "UTF-8") + "&b="
				+ URLEncoder.encode(b, "UTF-8") + "&k=" + URLEncoder.encode(k, "UTF-8") + "&f=" + f+ "&l=" + l);
		httpGet.setHeader("Authorization", "Bearer " + SUBSCRIPTION_KEY);
		List<String> featureList = new ArrayList<String>();
		CloseableHttpResponse resp = null;
		try {
			resp = httpClient.execute(httpGet);
			int statusCode = resp.getStatusLine().getStatusCode();
			String temp = EntityUtils.toString(resp.getEntity());
//				    System.out.println(temp);
			if (statusCode == 200) {

				JsonObject json = JsonParser.parseString(temp).getAsJsonObject();
				String error = json.get("error_code").toString().replaceAll("\"", "");
				if (!error.equals(""))
					throw new IllegalArgumentException(error);
				else {
					JsonArray values = json.get("response").getAsJsonObject().get(f).getAsJsonArray();
					for (int j = 0; j < values.size(); j++) {
						String str = values.get(j).toString();
						featureList.add(str.replaceAll("\"", ""));
					}
				}

			}
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			resp.close();
		}

		return featureList;
	}
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		try {
			List<String> list=getAPI2023("kids bike","Nike","lightweight, durable","listing","en");
			for (String l:list) {
					System.out.println(l);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
